#include <stdio.h>
#include "pngio.h"
#include "fo.c"
#include "render.c"

#define PAD 3

#define FW 5
#define FH 7

#define gx(x) ((x)*(FW+PAD*2+1))
#define gy(y) ((y)*(FH+PAD*2+1))
#define W     (gx(17)+1)
#define H     (gy(17)+1)


void mark(unsigned int *dst, int dw,int dh, int x0,int y0, int mw,int mh)
{
  int x,y;
  for(y=0;y<mh;y++)
   for(x=0;x<mw;x++)
     if ( (x0+x)<dw && (x0+x)>=0 && (y0+x)<dh && (y0+y)>=0)
        dst[(y0+y)*dw+(x0+x)]= 0xff000000;
}


int main(int argc,char **argv)
{
  unsigned int pix[W*H];
  unsigned int *ppix[H];
  int i,j;
  unsigned char* hex= "0123456789abcdef";
  memset(pix, 0xff, W*H*4);

  for(i=0;i<H;i++) ppix[i]= pix+i*W;

  for(i=0;i<16;i++)
  {
   int X,Y;
   X= gx(i+1)+2;
   Y= gy(0)+PAD+1;
   render_at(pix,W,H, X, Y, hex[i]);
   mark(pix,W,H, X+FW+1, Y+FH/2, 2,2);
   X= gx(0)+PAD*2;
   Y= gy(i+1)+PAD+1;
   render_at(pix,W,H, X, Y, hex[i]);
   mark(pix,W,H, X-3, Y+FH/2, 2,2);
  }
  for(i=0;i<17;i++)
  {
    for(j=0;j<H;j++) ppix[j][gx(i)]= 0xff888888;
    for(j=0;j<W;j++) ppix[gy(i)][j]= 0xff888888;
  }
  for(i=0;i<W;i++) ppix[H-1][i]= 0xff888888;
  for(i=0;i<H;i++) ppix[i][W-1]= 0xff888888;

  for(i=0;i<16;i++)
    for(j=0;j<16;j++)
     render_at(pix,W,H, gx(i+1)+PAD+1, gy(j+1)+PAD+1, (i<<4) | j);

  write_png_image("all.png",W,H,pix);
  return 0;
  
}
