#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pngio.h"
#include "fo.c"
#include "render.c"
#include "ptrbuf.h"


#define FW 5
#define FH 7
#define PAD 3
#define VSPC 1
#define HSPC 1


int main(int argc,char **argv)
{
  ptrbuf_t *lines;
  int nlines;
  int tab;
  int maxw;
  unsigned char* L;
  int W,H,X,Y;

  unsigned int *pix;
  unsigned int **ppix;
  int i;

  lines= ptrbuf_new(50);
  tab= 8;
  maxw= 0;

  nlines= 0;
  while(1)
  {
    int x;
    char g[2000];
    if (!fgets(g,sizeof(g),stdin)) break;
    g[sizeof(g)-1]= 0;
    x= 0;
    for(i=0;g[i];i++)
    {
      if (g[i]=='\r' || g[i]=='\n') { g[i]=0; break; }
      if (g[i]=='\t') { x+= tab-x%tab; continue; }
      x++;
    }
    if (x>maxw) maxw= x;
    ptrbuf_put(lines, strdup(g));
    nlines++;
  }
  if (nlines==0 || maxw==0) 
    exit(fprintf(stderr,"empty input\n"));

  W= maxw*FW+(maxw-1)*HSPC+2*PAD;
  H= nlines*FH+(nlines-1)*VSPC+2*PAD;

  pix= malloc(4*W*H);
  memset(pix, 0xff, W*H*4);

  ppix= malloc(sizeof(ppix[0])*H);
  for(i=0;i<H;i++) ppix[i]= pix+i*W;

  Y= PAD;
  while((L=ptrbuf_get(lines)))
  {
    X= PAD;
    for(i=0;L[i];i++)
      if (L[i]=='\t')
      {
        X+= (tab-i%tab)*(FW+HSPC);
      }
      else
      {
        render_at(pix,W,H,X,Y,L[i]);
        X+= FW+HSPC;
      }
    Y+= FH+VSPC;
  }

  write_png_image("out.png",W,H,pix);
  return 0;
}
